require 'tk'

class FontDialog
  ##################################################################
  # ᥽å
  #   եȻԤեȥ֥Ȥꤷޤ
  #   ʥȥåץ٥륦åȤ°ǽǤ
  #   mode  1 ξϡlatin եȤȴեȤȤ
  #   줾̡ bold °Ǥޤ
  #   parent ϿƤȤʤ륦åȤǤ
  ##################################################################
  def initialize(fontobj, mode = 1, parent = nil)
    # ɥ
    top = TkToplevel.new(parent)
    top.title('Font Dialog')

    # Ϳ줿եȥ֥Ȥ顢ߤͤ롣
    @config_font = fontobj
    compound_conf = {}
    @config_font.configinfo.each{|key, val| compound_conf[key] = val}
    latin_conf = {}
    @config_font.latin_configinfo.each{|key, val| latin_conf[key] = val}
    kanji_conf = {}
    @config_font.kanji_configinfo.each{|key, val| kanji_conf[key] = val}

    # °֤ɽ뤿Υեȥ֥Ȥ
    @font = TkFont.new(latin_conf, kanji_conf, compound_conf)

    @mode = mode

    ###########
    # оݤȤʤեȥ֥Ȥ̤ŬѤ뤫
    # 򤹤뤿Υܥ
    ret = TkVariable.new(0)
    f = TkFrame.new(top).pack('side'=>'bottom', 'fill'=>'x')
    TkButton.new(f, 'text'=>'OK', 'command'=>proc{
		   font_update(@config_font)
		   ret.value = 1
		 }).pack('side'=>'right')
    TkButton.new(f, 'text'=>'Cancel', 
		 'command'=>proc{ret.value = -1}).pack('side'=>'right')

    ###########
    # °֤ɽѤʸɽ
    msg = TkMessage.new(top, 'aspect'=>1000, 'borderwidth'=>10, 
			'font'=>@font, 'text'=>'
ABCDEFGHIJKLMNOPQRSTUVWXYZ
abcdefghijklmnopqrstuvwxyz
0123456789
!@#$%^&*()_+-=[]{};:"`\'~,.<>/?\\!


012abc(:)
').pack('side'=>'bottom')

    ###########
    # latin ե°Ѥ TkVariable
    @l_family = TkVariable.new(@font.latin_configinfo.assoc('family')[1])
    @l_size   = TkVariable.new(@font.latin_configinfo.assoc('size')[1])
    @l_bold   = TkVariable.new(@font.latin_configinfo.assoc('weight')[1])
    @l_slant  = TkVariable.new(@font.latin_configinfo.assoc('slant')[1])

    ###########
    # ե°Ѥ TkVariable
    @k_family = TkVariable.new(@font.kanji_configinfo.assoc('family')[1])
    @k_size   = TkVariable.new(@font.kanji_configinfo.assoc('size')[1])
    @k_bold   = TkVariable.new(@font.kanji_configinfo.assoc('weight')[1])
    @k_slant  = TkVariable.new(@font.kanji_configinfo.assoc('slant')[1])

    if @mode == 1
      ###########
      # latin եȤȴեȤȤΩ bold °
      ###########
      # ѤΥܥ
      ###########
      f_lfam  = TkFrame.new(top).pack('fill'=>'x')
      f_lsize = TkFrame.new(top).pack('fill'=>'x')
      b_lbold  = TkCheckButton.new(top, 'variable'=>@l_bold, 'text'=>'bold',
				   'offvalue'=>'normal', 'onvalue'=>'bold', 
				   'command'=>proc{font_update(@font)})
      b_lbold.pack('fill'=>'x', 'anchor'=>'e')
      b_lslant = TkCheckButton.new(top, 'variable'=>@l_slant, 
				   'text'=>'italic', 
				   'offvalue'=>'roman', 'onvalue'=>'italic', 
				   'command'=>proc{font_update(@font)})
      b_lslant.pack('fill'=>'x', 'anchor'=>'e')

      ###########
      TkLabel.new(top, 'text'=>' ').pack

      ###########
      f_kfam  = TkFrame.new(top).pack('fill'=>'x')
      f_ksize = TkFrame.new(top).pack('fill'=>'x')
      b_kbold  = TkCheckButton.new(top, 'variable'=>@k_bold, 'text'=>'bold',
				   'offvalue'=>'normal', 'onvalue'=>'bold', 
				   'command'=>proc{font_update(@font)})
      b_kbold.pack('fill'=>'x', 'anchor'=>'e')
      b_kslant = TkCheckButton.new(top, 'variable'=>@k_slant, 
				   'text'=>'italic', 
				   'offvalue'=>'roman', 'onvalue'=>'italic', 
				   'command'=>proc{font_update(@font)})
      b_kslant.pack('fill'=>'x', 'anchor'=>'e')

    else
      ###########
      # latin եȤȴեȤȤǶ̤ bold °
      ###########
      # ѤΥܥ
      ###########
      f_lfam  = TkFrame.new(top).pack('fill'=>'x')
      f_kfam  = TkFrame.new(top).pack('fill'=>'x')
      f_lsize = TkFrame.new(top).pack('fill'=>'x')
      b_lbold  = TkCheckButton.new(top, 'variable'=>@l_bold, 'text'=>'bold',
				   'offvalue'=>'normal', 'onvalue'=>'bold', 
				   'command'=>proc{font_update(@font)})
      b_lbold.pack('fill'=>'x', 'anchor'=>'e')
      b_lslant = TkCheckButton.new(top, 'variable'=>@l_slant, 
				   'text'=>'italic', 
				   'offvalue'=>'roman', 'onvalue'=>'italic', 
				   'command'=>proc{font_update(@font)})
      b_lslant.pack('fill'=>'x', 'anchor'=>'e')

    end

    ###########
    # latin եȥեߥѤΥȥܥåȥ˥塼ܥ
    TkLabel.new(f_lfam, 'text'=>'Latin Family').pack('side'=>'left')
    e = TkEntry.new(f_lfam, 'textvariable'=>@l_family).pack('side'=>'right')
    e.bind('Return', proc{font_update(@font)})
    b_lfam = TkMenubutton.new(f_lfam, 'text'=>'>>', 'borderwidth'=>1, 
			      'relief'=>'raised').pack('side'=>'right')
    l_menu = TkMenu.new(b_lfam, 'tearoff'=>false)
    b_lfam.menu(l_menu)

    ###########
    # եȥեߥѤΥȥܥåȥ˥塼ܥ
    TkLabel.new(f_kfam, 'text'=>'Kanji Family').pack('side'=>'left')
    e = TkEntry.new(f_kfam, 'textvariable'=>@k_family).pack('side'=>'right')
    e.bind('Return', proc{font_update(@font)})
    b_kfam = TkMenubutton.new(f_kfam, 'text'=>'>>', 'borderwidth'=>1, 
			      'relief'=>'raised').pack('side'=>'right')
    k_menu = TkMenu.new(b_kfam, 'tearoff'=>false)
    b_kfam.menu(k_menu)

    ###########
    # եȥեߥ˥塼ι
    #   ̾եȥեߥο¿Τǡ
    #   ŬʿȤˤޤȤ¿ؤΥ˥塼Ȥ
    allfonts  = TkFont.families.sort  # Ѳǽʥեȥեߥ
    limit = 20                        # ɽ򤳤οȤʬ
    if allfonts.size < limit
      allfonts.each{|fam|
	l_menu.add('radiobutton', 'label'=>fam, 'variable'=>@l_family, 
		   'value'=>fam, 'command'=>proc{font_update(@font)})
	k_menu.add('radiobutton', 'label'=>fam, 'variable'=>@k_family, 
		   'value'=>fam, 'command'=>proc{font_update(@font)})
      }
    else
      l_m = nil
      k_m = nil
      allfonts.each_with_index{|fam, idx|
	if idx % limit == 0
	  l_m = TkMenu.new(l_menu, 'tearoff'=>false)
	  l_menu.add('cascade', 'label'=>"#{fam} ...", 'menu'=>l_m)
	  k_m = TkMenu.new(k_menu, 'tearoff'=>false)
	  k_menu.add('cascade', 'label'=>"#{fam} ...", 'menu'=>k_m)
	end
	l_m.add('radiobutton', 'label'=>fam, 'variable'=>@l_family, 
		'value'=>fam, 'command'=>proc{font_update(@font)})
	k_m.add('radiobutton', 'label'=>fam, 'variable'=>@k_family, 
		'value'=>fam, 'command'=>proc{font_update(@font)})
      }
    end

    ###########
    # եȥѤΥȥܥå
    if @mode == 1
      ###########
      TkLabel.new(f_lsize, 'text'=>'Latin Size').pack('side'=>'left')
      e = TkEntry.new(f_lsize, 'textvariable'=>@l_size).pack('side'=>'right')
      e.bind('Return', proc{font_update(@font)})

      ###########
      TkLabel.new(f_ksize, 'text'=>'Kanji Size').pack('side'=>'left')
      e = TkEntry.new(f_ksize, 'textvariable'=>@k_size).pack('side'=>'right')
      e.bind('Return', proc{font_update(@font)})

    else
      ###########
      TkLabel.new(f_lsize, 'text'=>'Size').pack('side'=>'left')
      e = TkEntry.new(f_lsize, 'textvariable'=>@l_size).pack('side'=>'right')
      e.bind('Return', proc{font_update(@font)})
    end

    ###########
    # ΥǤλޤǡƤӽФ¦ػߤ
    top.grab
    ret.wait
    top.grab('release')
    top.destroy
  end

  #############################################################
  # 줿°ꤵ줿եȥ֥ȤŬ
  #############################################################
  def font_update(font)
    if @mode == 1
      font.latin_configure('family'=>@l_family.value, 'size'=>@l_size.value, 
			   'weight'=>@l_bold.value, 'slant'=>@l_slant.value)
      font.kanji_configure('family'=>@k_family.value, 'size'=>@k_size.value, 
			   'weight'=>@k_bold.value, 'slant'=>@k_slant.value)
      font.configure('size'=>@k_size.value, 
		     'pointadjust'=>@l_size.to_f/@k_size.to_f)
    else
      font.latin_configure('family'=>@l_family.value)
      font.kanji_configure('family'=>@k_family.value)
      font.configure('size'=>@l_size.value, 'weight'=>@l_bold.value, 
		     'slant'=>@l_slant.value)
    end
  end
end

#############################################################
#  Main routine
#############################################################
font = TkFont.new
TkMessage.new(nil, 'aspect'=>1000, 'borderwidth'=>10, 'font'=>font, 'text'=>'
ABCDEFGHIJKLMNOPQRSTUVWXYZ
abcdefghijklmnopqrstuvwxyz
0123456789
!@#$%^&*()_+-=[]{};:"`\'~,.<>/?\\!


012abc(:)
').pack

f = TkFrame.new.pack
TkButton.new(f, 'text'=>'dialog-1', 
	     'command'=>proc{FontDialog.new(font)}).pack('side'=>'left')
TkButton.new(f, 'text'=>'dialog-2', 
	     'command'=>proc{FontDialog.new(font, 0)}).pack('side'=>'left')
TkButton.new(f, 'text'=>'exit', 'command'=>proc{exit}).pack('side'=>'left')

Tk.mainloop
